/* Problem URL: https://codeforces.com/contest/2091/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m, d;
    cin >> n >> m >> d;

    int prev = d;
    d *= d;

    V<string> a(n);
    cin >> a;

    const ll mod = 998244353;

    vvl dp(n, vl(m + 1));

    dp[n - 1][0] = 1;

    int now = n - 1;

    auto dis = [&](ll x1, ll y1, ll x2, ll y2) {
        ll x = x1 - x2;
        ll y = y1 - y2;
        return x*x + y*y;
    };

    while (true) {
        nrep(i, 1, m + 1) {
            dp[now][i] = (dp[now][i] + dp[now][i - 1]) % mod;
        }

        dp[now][0] = 0;
        nrep(i, 1, m + 1) {
            if (a[now][i - 1] == '#') {
                dp[now][i] = 0;
            }
        }

        nrep(i, 1, m + 1) {
            dp[now][i] = (dp[now][i] + dp[now][i - 1]) % mod;
        }

        if (now == 0) {
            break;
        }
 
        nrep(i, 1, m + 1) {
            if (a[now][i - 1] == '#') {
                continue;
            }

            ll sum = ((dp[now][min(i + prev, m)] - dp[now][max(i - prev - 1, 0)]) % mod + mod) % mod;

            int cur = now - 1;
            int act = i - prev;
            while (dis(cur, act, now, i) > d) {
                act++;
            }

            int other = (i << 1) - act;

            dp[cur][max(act, 0)] += sum;
            dp[cur][max(act, 0)] %= mod;
            if (other < m) {
                dp[cur][other + 1] -= sum;
                dp[cur][other + 1] += mod * (dp[cur][other + 1] < 0);
            }

            cur--;
        }

        now--;
    }

    ll ans = 0;
    nrep(i, 1, m + 1) {
        if (a[0][i - 1] == '#') {
            continue;
        }

        ans = ((ans + dp[0][min(i + prev, m)] - dp[0][max(i - prev - 1, 0)]) % mod + mod) % mod;
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
